<!DOCTYPE html>
<html lang="en">
	<head>
		<meta charset="UTF-8">
		<meta name="viewport" content="width=device-width, initial-scale=1" />
		<style>
			@font-face {
				font-family: cozette;
				src: url(/cozette_vector.woff2);
			}
			body {
				background-color: black;
				font-family: cozette, monospace;
				font-size: 13px;
			}
			textarea {
				font-family: cozette, monospace;
				font-size: 13px;
				display: block;
				background-color: black;
				color: white;
				letter-spacing: 1px;
				padding: 10px;
				margin-top: 30px;
				margin-left: 30px;
				margin-bottom: 5px;
				width: calc(100% - 90px);
				line-height: 1;
				border-radius: 5px;
				border: 1px solid #ccc;
				box-shadow: 1px 1px 1px #999;
				resize: none
			}
			textarea,input:focus {
				outline: none;
				border: 1px solid pink;
			}
			input {
				font-family: cozette, monospace;
				font-size: 13px;
				background-color: black;
				color: white;
				border-radius: 5px;
				border: 1px solid #ccc;
				display: inline-block;
				width: calc(100% - 90px);
				padding: 10px;
				margin-left: 30px;
				margin-bottom: 5px;
				line-height: 1.5;
			}
			.buttons {
				display: inline-flex;
				margin-left: 30px;
			}
			button {
				font-family: cozette, monospace;
				font-size: 13px;
				scale: 100%;
				background-color: black;
				color: white;
				border-color: gray;
				border-radius: 5px;
				border: 1px solid #ccc;
				padding: 10px;
				margin-right: 8px;
			}
			button:hover {
				border: 2px solid pink;
			}
			button:disabled {
				display: none;
			}
			a {
				font-family: cozette, monospace;
				font-size: 13px;
				background-color: black;
				color: white;
				margin: 30px;
			}
			#btninput {
				display: block;
			}
			#input {
				display: block;
			}
		</style>
	</head>
	<body>
		<textarea id="chat" readonly cols="30" rows="10"></textarea>
		<div>
			<input id="input" type="text" placeholder="type here">
			<div class="buttons"><button id="btninput" type="button">send</button></div>
		</div>

		<script>
			const textarea = document.querySelector("#chat");
			const input = document.querySelector("#input");
			const btninput = document.querySelector("#btninput");
			function connect() {
				var ws = new WebSocket("wss://im.archneek.me/websocket");

				ws.onopen = function(msg) {
					console.log(`connection opened`);
					ws.send("joined");

					input.onkeydown = function(e) {
						if (e.key == "Enter") {
							ws.send(input.value);
							input.value = "";
						};
					};
					btninput.onclick = function() {
						ws.send(input.value);
						input.value = "";
					};
				};

				ws.onmessage = function(msg) {
					textarea.value += msg.data+"\r\n";
					textarea.scrollTo(0, textarea.scrollHeight);
				};

				ws.onclose = function(e) {
					input.onkeydown = null;
					input.onclick = null;

					setTimeout(function() {
						connect();
					}, 10);
				};

				ws.onerror = function(e) {
					console.log(e);
					ws.close();
				};

			};
			connect();
		</script>
		<footer>
			<p><a href=https://gitlab.com/archneek/im/websocket_stream/ws_im_server>server</a></p>
			<p><a href=https://gitlab.com/archneek/im/websocket_stream/ws_im_tui_client>tui client</a></p>
		</footer>
	</body>
</html>
